## elektra 0.8.14

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)

# allows us to override platform specific variables
set(CMAKE_USER_MAKE_RULES_OVERRIDE "${CMAKE_SOURCE_DIR}/cmake/Platform.cmake")

project (Elektra)

#fix OS X RPATH issues
set(CMAKE_MACOSX_RPATH 1)

#additional modules for loading libraries
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

#fix policy stuff
if (POLICY CMP0026)
	cmake_policy(SET CMP0026 OLD) # reinvestigate at 2.8.11 or later
endif()
if (POLICY CMP0043)
	cmake_policy(SET CMP0043 OLD) # to have consistent behavior for pre 2.8.10
	#also reinvestigate when they do not need to be supported anymore
endif()
if (POLICY CMP0046)
	cmake_policy(SET CMP0046 OLD) # new behaviour seems stupid, of course
	# dependency is not yet available if it's generated later?
endif()



#needed by ifs below
include (cmake/ElektraCache.cmake)
include (cmake/ElektraCompiling.cmake)
if (ENABLE_COVERAGE)
	include (cmake/ElektraCoverage.cmake)
endif (ENABLE_COVERAGE)

if (ENABLE_TESTING)
	enable_testing ()
	include (Dart)
endif (ENABLE_TESTING)


if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if (NOT FORCE_IN_SOURCE_BUILD)
		message(FATAL_ERROR
				"In-source builds are not permitted.\n"
				"Make a separate folder for building:\n"
				"    mkdir build && cd build && cmake ..\n"
				"Before that, remove the files already created:\n"
				"    rm -rf CMakeCache.txt CMakeFiles\n"
				"If you really know what you are doing\n"
				"(will overwrite original files!) use:\n"
				"    cmake -DFORCE_IN_SOURCE_BUILD=ON\n"
			)
	endif (NOT FORCE_IN_SOURCE_BUILD)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif (NOT CMAKE_BUILD_TYPE)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


#some basic and important variables
set (DOMAIN libelektra.org) #needed by doxygen
set (REVERSE_DOMAIN org.libelektra)

set (KDB_VERSION_MAJOR 0)
set (KDB_VERSION_MINOR 8)
set (KDB_VERSION_MICRO 14)

set (KDB_VERSION "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}.${KDB_VERSION_MICRO}")

set (SO_VERSION 4)
#set (SO_VERSION_TOOLS 3)

#needs version above
include (cmake/ElektraPackaging.cmake)

#now add all directories
add_subdirectory (cmake)
add_subdirectory (scripts)

if (BUILD_DOCUMENTATION)
	add_subdirectory (doc)
endif (BUILD_DOCUMENTATION)

#is there anything to build except documentation?
if (BUILD_FULL OR BUILD_STATIC OR BUILD_SHARED)
	if (BUILD_TESTING)
		find_package (GTest)
	endif (BUILD_TESTING)

	add_subdirectory (src)
	add_subdirectory (examples)
	add_subdirectory (benchmarks)

	if (BUILD_TESTING)
		add_subdirectory (tests)
	endif (BUILD_TESTING)
endif()

=== benchmarks/CMakeLists.txt ===
include (LibAddMacros)

add_headers (HDR_FILES)

macro (do_benchmark source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} benchmarks.c benchmarks.h ${source}.c)
	add_executable (${source} ${SOURCES})

	target_link_elektra(${source})

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)

	get_target_property (command ${source} LOCATION)

	add_custom_target (benchmark_${source}
		rm -f *.out
		COMMAND valgrind --tool=callgrind --callgrind-out-file=callgrind.out "${command}" > output.out
		# COMMAND strace -o strace.out "${command}"
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)
endmacro (do_benchmark)

do_benchmark (large)
do_benchmark (cmp)
do_benchmark (createkeys)

=== cmake/CMakeLists.txt ===
#ElektraPackaging needs to be included first (sets PACKAGE_ variables)

include (CMakePackageConfigHelpers)

#cmake settings for use by find_package
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/ElektraConfig.cmake.in"
		"${CMAKE_CURRENT_BINARY_DIR}/ElektraConfig.cmake"
		@ONLY
	)

write_basic_package_version_file (
		"${CMAKE_CURRENT_BINARY_DIR}/ElektraConfigVersion.cmake"
		VERSION ${KDB_VERSION}
		COMPATIBILITY AnyNewerVersion
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/ElektraConfig.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/ElektraConfigVersion.cmake"
		DESTINATION ${TARGET_CMAKE_FOLDER}
	)

#pkg-config files
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/elektra.pc.in"
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		DESTINATION lib${LIB_SUFFIX}/${TARGET_PKGCONFIG_FOLDER}
	)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/ElektraUninstall.cmake"
	WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
	COMMENT "Uninstalling Elektra from system or DESTDIR"
	)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

# do_doc
#
#builds and install documentation
#
#target  is man, html or latex
#folder  is the folder where it will be built
#file    is the file name to set a depencency to
#install is where it should be installed
#
macro (do_doc target folder file install)
	# sometimes doxygen is too slow and fails with "Could not create output directory .../doc/html"
	file(MAKE_DIRECTORY(${folder}))

	add_custom_command (
		OUTPUT ${folder}/${file}
		COMMAND ${DOXYGEN_EXECUTABLE}
		ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile markdownlinkconverter
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	)

	#get_filename_component (name ${target} NAME_WE)

	add_custom_target (${target} ALL
		DEPENDS ${folder}/${file}
	)

	if (INSTALL_DOCUMENTATION)
		install (
			DIRECTORY ${folder}
			DESTINATION ${install}
		)
	endif (INSTALL_DOCUMENTATION)
endmacro (do_doc)

if (DOXYGEN_FOUND)
	set (OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

	if (BUILD_PDF)
		find_package(LATEX)
		if (LATEX_COMPILER)
			set (WITH_LATEX YES)
		else (LATEX_COMPILER)
			set (WITH_LATEX NO)
			message (WARNING "Latex not found, PDF Manual can't be created.")
		endif (LATEX_COMPILER)
	else (BUILD_PDF)
		set (WITH_LATEX NO)
	endif (BUILD_PDF)

	if (DOXYGEN_DOT_FOUND)
		set (WITH_DOT YES)
	else (DOXYGEN_DOT_FOUND)
		set (WITH_DOT NO)
	endif (DOXYGEN_DOT_FOUND)

	find_package(Perl)

	add_executable (markdownlinkconverter markdownlinkconverter/markdownlinkconverter.c)
	# fix usage with wine
	# https://github.com/ElektraInitiative/libelektra/pull/340#discussion_r44044444
	find_util (markdownlinkconverter MARKDOWN_LINK_CONVERTER "")

	configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile"
		"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
		@ONLY
	)

	do_doc(html ${OUTPUT_DIRECTORY}/html/ index.html
		${TARGET_DOCUMENTATION_HTML_FOLDER})
	do_doc(man3 ${OUTPUT_DIRECTORY}/man/man3elektra/ kdb.3elektra
		"${TARGET_DOCUMENTATION_MAN_FOLDER};PATTERN;_*;EXCLUDE")

	if (WITH_LATEX)
		do_doc(latex ${OUTPUT_DIRECTORY}/latex/ refman.tex
			${TARGET_DOCUMENTATION_LATEX_FOLDER})

		file (COPY "${CMAKE_CURRENT_SOURCE_DIR}/markdownlinkconverter/elektraSpecialCharacters.sty"
				DESTINATION "${OUTPUT_DIRECTORY}/latex/")

		add_custom_command (
			OUTPUT ${OUTPUT_DIRECTORY}/latex/refman.pdf
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			COMMAND ${PDFLATEX_COMPILER} ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.tex markdownlinkconverter
			WORKING_DIRECTORY ${OUTPUT_DIRECTORY}/latex/
		)

		add_custom_target (pdf ALL
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.pdf
		)
	endif (WITH_LATEX)
else (DOXYGEN_FOUND)
	message (WARNING "Doxygen not found, Reference Manual can't be created even though requested with BUILD_DOCUMENTATION.")
endif (DOXYGEN_FOUND)

add_subdirectory(help)

=== examples/CMakeLists.txt ===
include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_example source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c)
	add_executable (${source} ${SOURCES})

	target_link_elektra(${source})

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
endmacro (do_example)

file (GLOB TESTS *.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_example (${name})
endforeach (file ${TESTS})

=== scripts/CMakeLists.txt ===
install (PROGRAMS benchmark-createtree DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

install (PROGRAMS elektra-merge DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS elektra-mount DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS elektra-umount DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

install (PROGRAMS convert-fstab DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS convert-hosts DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS convert-inittab DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS convert-users DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

install (PROGRAMS example-xorg DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

install (PROGRAMS mount-augeas DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS mount-info DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS mount-kde DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
install (PROGRAMS mount-openicc DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

install (PROGRAMS umount-all DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

if (INSTALL_SYSTEM_FILES)
	install (FILES kdb-bash-completion
			DESTINATION /etc/bash_completion.d
			RENAME kdb)
	install (FILES elektraenv.sh
			DESTINATION /etc/profile.d
			RENAME kdb)
endif()

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/elektrify-getenv.in"
	"${CMAKE_CURRENT_BINARY_DIR}/elektrify-getenv")
install (PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/elektrify-getenv" DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/make-source-package.in"
	"${CMAKE_CURRENT_BINARY_DIR}/make-source-package")

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/list-tools.in"
	"${CMAKE_CURRENT_BINARY_DIR}/list-tools")
install (PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/list-tools" DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/mount-spec.in"
	"${CMAKE_CURRENT_BINARY_DIR}/mount-spec")
install (PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/mount-spec" DESTINATION ${TARGET_TOOL_EXEC_FOLDER})

ADD_CUSTOM_TARGET(source-package
		COMMAND "${CMAKE_CURRENT_BINARY_DIR}/make-source-package"
		COMMENT "Make a elektra source package by using git"
		VERBATIM
		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
		)

=== src/CMakeLists.txt ===

add_subdirectory (include)

add_subdirectory (liberror)

add_subdirectory (libloader)

add_subdirectory (plugins)

add_subdirectory (libelektra)

add_subdirectory (bindings)

add_subdirectory (libtools)

add_subdirectory (tools)

add_subdirectory (libgetenv)

=== tests/CMakeLists.txt ===
## Elektra Test Suite
#
# This file is responsible for generating all tests
# regarding elektra's core.
#
# Backends and Bindings specific tests might be in
# their folders.

include (LibAddMacros)

#don't call add_headers in a loop
add_headers (HDR_FILES)

macro (do_test source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c $<TARGET_OBJECTS:cframework>)
	add_headers(SOURCES)
	add_testheaders(SOURCES)
	add_executable (${source} ${SOURCES})

	if (INSTALL_TESTING)
		install (TARGETS ${source}
			DESTINATION ${TARGET_TOOL_EXEC_FOLDER})
	endif (INSTALL_TESTING)

	target_link_elektra(${source})

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (${source} PROPERTIES LINKER_LANGUAGE CXX)
	add_test (${source}
			"${CMAKE_BINARY_DIR}/bin/${source}"
			"${CMAKE_CURRENT_BINARY_DIR}"
			)
endmacro (do_test)

add_custom_target(run_all
	COMMAND ${CMAKE_CTEST_COMMAND}
	--force-new-ctest-process --output-on-failure
	--build-config "$<CONFIGURATION>"
	WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")

add_custom_target(run_memcheck
	COMMAND "${CMAKE_SOURCE_DIR}/scripts/run_memcheck"
	"$<CONFIGURATION>"
	WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")

include_directories(data)

add_subdirectory (cframework)
add_subdirectory (shell)
add_subdirectory (abi)
add_subdirectory (ctest)
add_subdirectory (kdb)

=== doc/help/CMakeLists.txt ===
find_program (RONN_LOC ronn)

if (RONN_LOC)
	add_custom_target (man ALL)


	file (GLOB KDBNAMES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} kdb*.md)
	foreach (FULLNAME ${KDBNAMES})
		get_filename_component (NAME ${FULLNAME} NAME_WE)
		generate_manpage (${NAME})
	endforeach ()

	file (GLOB KDBNAMES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} elektra*.md)
	foreach (FULLNAME ${KDBNAMES})
		get_filename_component (NAME ${FULLNAME} NAME_WE)
		generate_manpage (${NAME} SECTION 7)
	endforeach ()
else ()
	message (WARNING "did not find ronn, cannot build man pages even though requested with BUILD_DOCUMENTATION.")
endif ()

=== src/bindings/CMakeLists.txt ===
list (FIND BINDINGS "cpp" FINDEX)
if (FINDEX GREATER -1)
	message(STATUS "Include Binding cpp")
	add_subdirectory (cpp)
endif()

list (FIND BINDINGS "jna" FINDEX)
if (FINDEX GREATER -1)
	message(STATUS "Include Binding jna")
	add_subdirectory (jna)
endif()

set(regex "swig_.*")
list_find(BINDINGS regex found)
if (found)
	message(STATUS "Include Binding swig")
	find_swig()
	if (SWIG_FOUND)
		add_subdirectory (swig)
	else()
		list_filter(BINDINGS regex)
		remove_binding(swig "neither swig2/3 found. Please install swig3.0 and set -DSWIG_EXECUTABLE=")
	endif()
endif()

list (FIND BINDINGS "glib" FINDEX)
if (FINDEX GREATER -1)
	set (GELEKTRA_LIBRARY gelektra-${SO_VERSION}.0)
	add_subdirectory (glib)

	set(regex "gi_.*")
	list_find(BINDINGS regex found)
	if (found)
		add_subdirectory (gi)
	endif ()
endif ()

=== src/include/CMakeLists.txt ===
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)

check_symbol_exists(clearenv     "stdlib.h"         HAVE_CLEARENV)
check_symbol_exists(setenv       "stdlib.h"         HAVE_SETENV)
check_symbol_exists(futimens     "sys/stat.h"       HAVE_FUTIMENS)
check_symbol_exists(futimes      "sys/time.h"       HAVE_FUTIMES)

check_include_file(ctype.h      HAVE_CTYPE_H)
check_include_file(errno.h      HAVE_ERRNO_H)
check_include_file(locale.h     HAVE_LOCALE_H)
check_include_file(stdio.h      HAVE_STDIO_H)
check_include_file(stdlib.h     HAVE_STDLIB_H)
check_include_file(string.h     HAVE_STRING_H)
check_include_file(time.h       HAVE_TIME_H)
check_include_file(unistd.h     HAVE_UNISTD_H)

check_type_size(int             SIZEOF_INT)
check_type_size(long            SIZEOF_LONG)
check_type_size("long long"     SIZEOF_LONG_LONG)
check_type_size("long double"   SIZEOF_LONG_DOUBLE)
check_type_size(mode_t          SIZEOF_MODE_T)

set (BUILTIN_EXEC_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TOOL_EXEC_FOLDER}")
set (BUILTIN_DATA_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${TARGET_TEST_DATA_FOLDER}")
set (ELEKTRA_DEPRECATED "__attribute__ ((deprecated))")
set (ELEKTRA_UNUSED "__attribute__ ((unused))")

set (BUILTIN_SPEC_FOLDER
	"${CMAKE_INSTALL_PREFIX}/${KDB_DB_SPEC}")

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdb.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbconfig.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbversion.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	)

install (FILES
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	kdbextension.h
	kdbmeta.h
	kdbtypes.h
	kdbhelper.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	kdbmodule.h
	kdbos.h
	kdbplugin.h
	kdbprivate.h
	kdbproposal.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	DESTINATION include/${TARGET_INCLUDE_FOLDER})

=== src/libelektra/CMakeLists.txt ===
# For static inclusion of libraries we need a list
# of symbols to make the static runtime linker work.
#
# For that there is the program exportsymbols which
# generates the sourcefiles exported_symbols.h
# and exported_symbols.c containing an array of
# all symbols.
#
# The program needs a list of all backends as
# argument.
#
# Symbols of libelektratools will be treaded specially.
add_executable (exportsymbols exportsymbols.c)

include(LibAddMacros)
find_util(exportsymbols EXE_SYM_LOC EXE_SYM_ARG)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${EXE_SYM_ARG} ${PLUGINS}
		)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${EXE_SYM_ARG} ${PLUGINS}
		)


# Include the shared header files of the elektra project
include(LibAddMacros)
add_headers(HDR_FILES)
# not always needed.. only with cppplugins
add_cppheaders(HDR_FILES)

#include the current binary directory to get exported_symbols.h
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

#now add all source files of this folder
file (GLOB SRC_FILES *.c)

#remove those we don't want..
file (GLOB RM_FILES exportsymbols.c kdbmainpage.c)
list (REMOVE_ITEM SRC_FILES ${RM_FILES} ${WIN32_RM_FILES})

#now add all source files of other folders
get_property (elektra_SRCS GLOBAL PROPERTY elektra_SRCS)
list (APPEND SRC_FILES ${elektra_SRCS})

set (SOURCES ${SRC_FILES} ${HDR_FILES})
list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h")

#the targets built to export
set (targets_built)

SET(__symbols_file ${CMAKE_CURRENT_SOURCE_DIR}/libelektra-symbols.map)

if (BUILD_SHARED)
	get_property (elektra-shared_SRCS GLOBAL PROPERTY elektra-shared_SRCS)
	add_library (elektra SHARED ${SOURCES} ${elektra-shared_SRCS})

	get_property (elektra-shared_LIBRARIES GLOBAL PROPERTY elektra-shared_LIBRARIES)
	target_link_libraries (elektra ${elektra-shared_LIBRARIES})

	get_property (elektra-shared_INCLUDES GLOBAL PROPERTY elektra-shared_INCLUDES)
	include_directories (${elektra-shared_INCLUDES})

	set_target_properties (elektra PROPERTIES
		COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H"
		VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION}
		CLEAN_DIRECT_OUTPUT 1
	)
	if (${LD_ACCEPTS_VERSION_SCRIPT})
		set_target_properties (elektra PROPERTIES
			LINK_FLAGS "-Wl,--version-script=${__symbols_file}"
		)
	endif ()

	#RPATH settings, see http://www.itk.org/Wiki/CMake_RPATH_handling
	#those settings are needed to find the plugins at runtime even without ld.so.conf
	#search only in the prefix the user decided to install elektra
	#(e.g. /usr/local/)
	set (ELEKTRA_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER}")
	set_target_properties (elektra PROPERTIES INSTALL_RPATH "${ELEKTRA_RPATH}")

	install (TARGETS elektra DESTINATION lib${LIB_SUFFIX} EXPORT ElektraTargetsLibelektra)

	list (APPEND targets_built elektra)
endif (BUILD_SHARED)

if (BUILD_FULL OR BUILD_STATIC)
	#for the next two builds, append some more sources
	get_property (elektra-full_SRCS GLOBAL PROPERTY elektra-full_SRCS)
	list (APPEND SOURCES ${elektra-full_SRCS}
		${BINARY_INCLUDE_DIR}/kdberrors.h)
	list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c")

	#and get all libraries to link against
	get_property (elektra-full_LIBRARIES GLOBAL PROPERTY elektra-full_LIBRARIES)

	# include the directories of all libraries for the static or
	# full-shared build
	get_property (elektra-full_INCLUDES GLOBAL PROPERTY elektra-full_INCLUDES)

	include_directories (${elektra-full_INCLUDES})
endif (BUILD_FULL OR BUILD_STATIC)


if (BUILD_FULL)
	add_library (elektra-full SHARED ${SOURCES})

	target_link_libraries (elektra-full ${elektra-full_LIBRARIES})

	set_target_properties (elektra-full PROPERTIES
		COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC"
		VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION}
		CLEAN_DIRECT_OUTPUT 1
		LINKER_LANGUAGE CXX
	)
	if (${LD_ACCEPTS_VERSION_SCRIPT})
		set_target_properties (elektra-full PROPERTIES
			LINK_FLAGS "-Wl,--version-script=${__symbols_file}"
		)
	endif ()

	install (TARGETS elektra-full DESTINATION lib${LIB_SUFFIX} EXPORT ElektraTargetsLibelektra)

	list (APPEND targets_built elektra-full)
endif (BUILD_FULL)


if (BUILD_STATIC)
	add_library (elektra-static STATIC ${SOURCES})

	target_link_libraries (elektra-static ${elektra-full_LIBRARIES})

	set_target_properties (elektra-static PROPERTIES
		COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC"
		VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION}
		CLEAN_DIRECT_OUTPUT 1
		LINKER_LANGUAGE CXX
	)
	if (${LD_ACCEPTS_VERSION_SCRIPT})
		set_target_properties (elektra-static PROPERTIES
			LINK_FLAGS "-Wl,--version-script=${__symbols_file}"
		)
	endif ()

	install (TARGETS elektra-static DESTINATION lib${LIB_SUFFIX} EXPORT ElektraTargetsLibelektra)

	list (APPEND targets_built elektra-static)
endif (BUILD_STATIC)

export (TARGETS ${targets_built} FILE "${CMAKE_CURRENT_BINARY_DIR}/ElektraTargetsLibelektra.cmake")
install (EXPORT ElektraTargetsLibelektra DESTINATION "${TARGET_CMAKE_FOLDER}")

#if you want the same name for those 3 libraries, here is how to do it:
#http://www.itk.org/Wiki/CMake_FAQ#How_do_I_make_my_shared_and_static_libraries_have_the_same_root_name.2C_but_different_suffixes.3F

=== debian/changelog ===
elektra (0.8.14-5) unstable; urgency=medium

  * Replace patch lua-fix-Key-tostring.diff with upstream
    upstream_lua-fix-Key-tostring.patch.
  * Replace patches python-fix-flags-in-Key.diff and lua-fix-flags-in-Key.diff
    with upstream upstream_bindings-fix-size-of-KEY_FLAGS-value.patch.
  * Enable the augeas plugin:
    - add the libaugeas-dev build dependency
    - create a new libelektra4-augeas package
  * Create a new libelektra4-lua for the lua plugin.
  * Create a new libelektra4-python for the python plugin.
  * Improve the libelektragetenv.so handling:
    - move it from elektra-bin to libelektra4, adding proper breaks/replaces
    - help dh_shlibdeps finding it
    - exclude it from the shared libraries (dh_makeshlibs job)
  * Enable the Qt gui:
    - add the qtbase-dev, qtdeclarative5-dev, libmarkdown2-dev, and discount
      build dependencies
    - create a new elektra-qt-gui package
  * Link in as-needed mode.
  * Add in libelektra4 all the plugins as suggests.
  * Backport upstream commit b547ec94840f155c0fe517afdcf46043a99c8b04 to mark
    the convert-hosts script as bash-specific; patch
    upstream_convert-hosts-switch-to-bash.patch.

 -- Pino Toscano <pino@debian.org>  Sun, 13 Dec 2015 20:40:57 +0100

elektra (0.8.14-4) unstable; urgency=medium

  * Fix the lua binding, to not return free'd memory in Key:tostring();
    patch lua-fix-Key-tostring.diff.
  * Fix the handling of KEY_FLAGS in the vararg constructor of Key, in both
    lua and python3 bindings; patches python-fix-flags-in-Key.diff and
    lua-fix-flags-in-Key.diff.

 -- Pino Toscano <pino@debian.org>  Tue, 08 Dec 2015 22:55:12 +0100

elektra (0.8.14-3) unstable; urgency=medium

  * examples-c-pp autopkgtest: build the C++ examples with -std=c++11,
    as it is required by the C++ API now.
  * python3-elektra: fix path to the examples.
  * Fix the elektra-getenv libc wrapper on powerpc; patch getenv-ppc.diff.
  * Fix build without PATH_MAX; patch path-max.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 05 Dec 2015 15:09:42 +0100

elektra (0.8.14-2) unstable; urgency=medium

  * Do not disable the documentation on arch-only builds, as that disables
    also the extra man pages.
  * Move ruby-ronn as normal build dependency, to be always installed.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Nov 2015 20:31:39 +0100

elektra (0.8.14-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Fix-vararg-type-for-KEY_FLAGS.patch: drop, backported
    - upstream_fix-238-keyName-example.patch: drop, backported
    - private_elektratools.diff: refresh
  * Re-enable usage of system gtest, as it has been fixed upstream.
  * Update install files.
  * Update copyright.
  * Update lintian overrides.
  * Make elektra-tests depend on elektra-bin, as the latter contains the
    elektra-getenv stuff.
  * Workaround the internal broken list_filter() cmake function; patch
    avoid-list-filter.diff.
  * Update symbols file.
  * Add ruby-ronn as Build-Depends-Indep, as it's used in the generation of
    the documentation.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Nov 2015 18:25:01 +0100

elektra (0.8.12-2) unstable; urgency=medium

  * Upload to unstable.
  * autopkgtest tests: switch from `...` syntax to $(...).
  * Backport upstream commit aca7c1e86285319bb41dde8eb3e5feb71a902931 to fix
    extraction of KEY_FLAGS varargs (crashes on powerpc, for example); patch
    upstream_Fix-vararg-type-for-KEY_FLAGS.patch.
  * Backport upstream commit 0b56b84154497078d7d084611b9f6adeb074b4d2 to fix
    the keyName.c example; patch upstream_fix-238-keyName-example.patch.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Sun, 26 Jul 2015 10:03:55 +0200

elektra (0.8.12-1) experimental; urgency=medium

  * New upstream release:
    - HTML_TIMESTAMP is off by default (Closes: #788879)
  * Update the patches:
    - upstream_Add-the-KEY_END-marker-on-key-creation-where-missing.patch:
      drop, backported
    - upstream_tests-switch-from-tmpnam-to-mkstemp.patch: drop, backported
    - upstream_cmake-check-and-store-the-size-of-mode_t.patch: drop, backported
    - upstream_Make-KEY_MODE-work-when-mode_t-is-not-the-same-as-in.patch:
      drop, backported
    - private_elektratools.diff: refresh
    - path_max.diff: drop, fixed upstream
    - ambiguous_keyset_ctor.diff: drop, the underlying problem should have
      been fixed upstream
  * Update install files.
  * Update symbols file.
  * examples-c-pp autopkgtest: make the cmake build verbose, and exclude
    namespace.c (requires stdin).
  * Update lintian overrides.
  * rules: replace -DBUILD_SWIG=ON, -DBUILD_SWIG_LUA=ON, and
    -DBUILD_SWIG_PYTHON3=ON with -DBINDINGS="ALL".
  * Elektra now installs the bash completion on its own, so:
    - drop the usage of the bash-completion dh addon
    - drop elektra-bin.bash-completion
    - drop the bash-completion build dependency
    - move it manually to /usr/share/bash-completion/completions/, as
      /etc/bash_completion.d/ is deprecated
  * Temporarily use the own copy of gtest, as there is a file there which
    is not provided in the system version; problem reported and fixed upstream
    as https://github.com/ElektraInitiative/libelektra/pull/236.
  * Bump Standards-Version to 3.9.6, no changes required.
  * control: rename XS-Testsuite to Testsuite.
  * rules: skip also the testscrtestkdb_* tests, as they require root access.

 -- Pino Toscano <pino@debian.org>  Thu, 23 Jul 2015 08:18:17 +0200

=== debian/control ===
Source: elektra
Section: misc
Priority: optional
Maintainer: Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 9),
 cmake (>= 2.8),
 pkg-config (>= 0.9.0),
 libboost-dev,
 libdbus-1-dev,
 libyajl-dev,
 libxml2-dev,
 libaugeas-dev,
 qtbase5-dev, qtdeclarative5-dev, libmarkdown2-dev, discount,
 swig3.0,
 dh-lua,
 python3-dev,
 libgtest-dev,
 ruby-ronn,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 3.9.6
Homepage: http://www.libelektra.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/pino/elektra.git
Vcs-Git: git://anonscm.debian.org/users/pino/elektra.git
Testsuite: autopkgtest

Package: libelektra4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: elektra-bin (<< 0.8.14-5~)
Replaces: elektra-bin (<< 0.8.14-5~)
Suggests: elektra-doc, ${elektra:allPlugins}
Description: elektra configuration store, main library
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the main elektra library, and most of the core plugins.

Package: libelektra-dev
Section: libdevel
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, main library [development]
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the development files for the main elektra library.

#Package: libelektratools4
#Section: libs
#Architecture: any
#Multi-Arch: same
#Pre-Depends: ${misc:Pre-Depends}
#Depends: libelektra4 (= ${binary:Version}),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: elektra configuration store, elektratools library
# Elektra provides a universal and secure framework to store configuration
# parameters in a hierarchical key-value pair mechanism, instead of each
# program using its own text configuration files. This allows any program
# to read and save its configuration with a consistent API, and allows
# them to be aware of other applications' configurations, permitting
# easy application integration. While architecturally similar to other OS
# registries, Elektra does not have most of the problems found in those
# implementations.
# .
# This package contains the elektratools library.
#
#Package: libelektratools-dev
#Section: libdevel
#Architecture: any
#Depends: libelektratools4 (= ${binary:Version}),
# libelektra-dev (= ${binary:Version}),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: elektra configuration store, elektratools library [development]
# Elektra provides a universal and secure framework to store configuration
# parameters in a hierarchical key-value pair mechanism, instead of each
# program using its own text configuration files. This allows any program
# to read and save its configuration with a consistent API, and allows
# them to be aware of other applications' configurations, permitting
# easy application integration. While architecturally similar to other OS
# registries, Elektra does not have most of the problems found in those
# implementations.
# .
# This package contains the development files for the elektratools library.

Package: libelektra4-augeas
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, augeas plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'augeas' plugin.

Package: libelektra4-dbus
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, dbus plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'dbus' plugin.

Package: libelektra4-lua
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, lua plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'lua' plugin.

Package: libelektra4-python
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, python plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'python' plugin.

Package: libelektra4-xmltool
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, xmltool plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'xmltool' plugin.

Package: libelektra4-yajl
Section: libs
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, yajl plugin
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the 'yajl' plugin.

Package: lua-elektra
Section: interpreters
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, Lua bindings
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the Lua bindings.

Package: python3-elektra
Section: python
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${python3:Depends},
 ${misc:Depends}
Description: elektra configuration store, Python 3 bindings
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains the Python 3 bindings.

Package: elektra-bin
Architecture: any
Multi-Arch: foreign
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: kernel-patch-kdb
Description: elektra configuration store, binaries
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains command line utilities for Elektra.

Package: elektra-qt-gui
Architecture: any
Depends: libelektra4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: elektra configuration store, Qt gui
 Elektra provides a universal and secure framework to store configuration
 parameters in a hierarchical key-value pair mechanism, instead of each
 program using its own text configuration files. This allows any program
 to read and save its configuration with a consistent API, and allows
 them to be aware of other applications' configurations, permitting
 easy application integration. While architecturally similar to other OS
 registries, Elektra does not have most of the problems found in those
 implementations.
 .
 This package contains a Qt-based graphical interface for Elektra.

Package: elektra-tests
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libelektra4 (= ${binary:Version}),
 elektra-bin (= ${binary:Version}),
 ${shlibs:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PY3VER = $(shell py3versions -d -v)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
  -DTARGET_PLUGIN_FOLDER="elektra4" \
  -DPLUGINS="ALL" \
  -DTOOLS="ALL" \
  -DBUILD_STATIC=OFF \
  -DBINDINGS="ALL" \
  -DSWIG_EXECUTABLE="/usr/bin/swig3.0" \
  -DPython_ADDITIONAL_VERSIONS="$(PY3VER)" \
  -DGTEST_ROOT="/usr/src/gtest" \
  -DTARGET_DOCUMENTATION_HTML_FOLDER="share/doc/elektra-doc/html"
T = $(CURDIR)/teststmp
EMPTY =
SPACE = $(EMPTY) $(EMPTY)
COMMA_SPACE = ,$(SPACE)
PKGS_ALL_PLUGINS = $(subst $(SPACE),$(COMMA_SPACE),$(filter libelektra4-%,$(shell dh_listpackages)))

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --buildsystem=cmake --with lua,python3

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(CMAKE_ARGS)

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p "$(T)"
	cd obj-* && env HOME="$(T)" TMPDIR="$(T)" ctest --output-on-failure -E '(testscr|testkdb)_.*'
	find "$(T)" | sort
	rm -rf "$(T)"
endif

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp \( -name '*.map' -o -name '*.md5' \) -delete

override_dh_install:
	dh_install --list-missing

override_dh_compress:
	dh_compress -X.lua -Xexamples

override_dh_strip:
	dh_strip --dbg-package=elektra-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/elektra4 -Xlibelektragetenv.so

override_dh_shlibdeps:
	# to find libelektragetenv.so
	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_gencontrol:
	dh_gencontrol -- -Velektra:allPlugins='$(PKGS_ALL_PLUGINS)'

=== debian/tests/control ===
Tests: elektra-tests
Depends: elektra-tests
Restrictions: allow-stderr

Tests: examples-c-cpp
Depends: build-essential, pkg-config, cmake, libelektra-dev

Tests: examples-python3
Depends: python3-elektra

Tests: examples-lua
Depends: lua5.2, lua-elektra

=== debian/watch ===
version=3
http://sf.net/elektra/elektra-(.*)\.tar\.gz
ftp://ftp.libelektra.org/elektra/releases/elektra-(.*)\.tar\.gz
